--[[	A special thank you to DarlosD9 and Darkstorm Technologies for this list of key numbers.

	A - 1		S - 19		Numpad 0 - 37		ins  - 76
	B - 2		T - 20		Numpad 1 - 38		del  - 77
	C - 3		U - 21		Numpad 2 - 39		home - 78
	D - 4		V - 22		Numpad 3 - 40		end  - 79
	E - 5		W - 23		Numpad 4 - 41		page up - 80
	F - 6		X - 24		Numpad 5 - 42		page down - 81
	G - 7		Y - 25		Numpad 6 - 43		left arrow - 82
	H - 8		Z - 26		Numpad 7 - 44		right arrow - 83
	I - 9		0 - 27		Numpad 8 - 45		up arrow - 84
	J - 10		1 - 28		Numpad 9 - 46		down arrow - 85
	K - 11		2 - 29		- - 61			numpad / - 86
	L - 12		3 - 30		= - 62			numpad * - 87
	M - 13		4 - 31		{ - 65			numpad - - 88
	N - 14		5 - 32		} - 66			numpad + - 89
	O - 15		6 - 33		" - 69			numpad . - 90
	P - 16		7 - 34		\ - 70			;  - 105
	Q - 17		8 - 35		, - 72
	R - 18		9 - 36		. - 73
]]

function Create(self)
	function SecondaryKey()
		return (UInputMan:KeyHeld(24) or UInputMan:KeyHeld(26))	-- X or Z, replace with a number form the list above
	end
	
	self.SecondaryTimer = Timer()
	self.GunTimer = Timer()
	self.FlippTimer = Timer()
	self.GearTimer = Timer()
	self.Frame = self.FrameCount - 1
	self.flipp = 0
	self.aim = self.RotAngle
	self.AimDots = {}
	self.maxAmmo = 500
	self.ammo = self.maxAmmo
	self.maxPayload = 200
	self.payload = self.maxPayload
	self.SharpLength = Vector(FrameMan.PlayerScreenWidth/2.7, FrameMan.PlayerScreenHeight/3)
	self.gear = 0
	self.player = false	-- player is in control
	self.landingMode = false
	self.EngineOn = true
	self.Ctrl = self:GetController()
	self.AnalogAim = self.Ctrl:IsMouseControlled()
	
	-- Find landing pads
	self.LandingPads = {}
	for Act in MovableMan.Actors do
		if Act.Team == self.Team and Act.PresetName == "Repair System" then
			table.insert(self.LandingPads, Act)
		end
	end
end

function Destroy(self)
	if MovableMan:IsParticle(self.Barrel) then
		self.Barrel.ToDelete = true
	end

	for i = 1, 3 do
		if MovableMan:IsParticle(self.AimDots[i]) then
			self.AimDots[i].ToDelete = true
		end
	end
	
	if MovableMan:IsParticle(self.PayloadIcon) then
		self.PayloadIcon.ToDelete = true
	end
	
	if MovableMan:IsParticle(self.MGIcon) then
		self.MGIcon.ToDelete = true
	end
end

function Update(self)
	if self.Health < 1 then
		self:GibThis()
	end

	local gunAim = 0
	local GunOffset = self.Pos + self:RotateOffset(Vector(28, 24))
	
	-- Avoid self destruct
	if self.RotAngle > 6.2832 then
		self.RotAngle = self.RotAngle - 6.2832
	elseif self.RotAngle < -1.5708 then
		self.RotAngle = self.RotAngle + 6.2832
	end
	
	-- Validate barrel
	if not MovableMan:IsParticle(self.Barrel) or self.Barrel.PresetName ~= "My MG Barrel" then
		self.Barrel = CreateMOSRotating("My MG Barrel", "MyGunship.rte")
		MovableMan:AddParticle(self.Barrel)
		self.Barrel.Pos = GunOffset
		self.Barrel.RotAngle = gunAim
	end
	
	if self:IsPlayerControlled() then
		self.player = true
		
		-- Double or tripple tapp movement keys to flipp
		if self.flipp ~= 0 and self.FlippTimer:IsPastRealMS(200) then
			self.flipp = 0
		end
		
		if self.HFlipped then
			if self.Ctrl:IsState(Controller.PRESS_RIGHT) then
				self.FlippTimer:Reset()
				self.flipp = self.flipp + 1
				if self.Ctrl:IsMouseControlled() then
					if self.flipp > 1 then
						self.flipp = nil
					end
				elseif self.flipp > 2 then
					self.flipp = nil
				end
			end
		elseif self.Ctrl:IsState(Controller.PRESS_LEFT) then
			self.FlippTimer:Reset()
			self.flipp = self.flipp - 1
			if self.Ctrl:IsMouseControlled() then
				if self.flipp < -1 then
					self.flipp = nil
				end
			elseif self.flipp < -2 then
				self.flipp = nil
			end
		end
		
		if not self.flipp then
			self.HFlipped = not self.HFlipped
			self.aim = 3.1415 - self.aim
			self.flipp = 0
		end
		
		-- Tripple tapp down key for landing gears
		if self.gear ~= 0 and self.GearTimer:IsPastRealMS(250) then
			self.gear = 0
		end
		
		if self.Ctrl:IsState(Controller.PRESS_DOWN) then
			self.GearTimer:Reset()
			self.gear = self.gear + 1
			if self.gear > 2 then
				local sound = false
				if self.Frame == self.FrameCount - 1 then	-- Gears are in
					self.Frame = self.Frame - 1
					self.landingMode = true
					sound = true
				elseif self.Frame == 0 then	-- Gears are out
					self:SetNextFrame()
					self.landingMode = false
					sound = true
				end
				
				if sound then
					local Emitter = CreateAEmitter("Gear Sound", "Gunship.rte")
					Emitter.Vel = self.Vel
					Emitter.Pos = self.Pos
					MovableMan:AddParticle(Emitter)
				end
			end
		end
		
		-- Update MG ammo icon
		if not MovableMan:IsParticle(self.MGIcon) or self.MGIcon.PresetName ~= "MG Ammo" then
			self.MGIcon = CreateMOSRotating("MG Ammo", "Gunship.rte")
			self.MGIcon.Frame = math.ceil((self.MGIcon.FrameCount-1) * self.ammo / self.maxAmmo)
			MovableMan:AddParticle(self.MGIcon)
		end
		
		self.MGIcon.Vel = self.Vel
		self.MGIcon.AngularVel = 0
		self.MGIcon.RotAngle = 0
		self.MGIcon.Pos = self.AboveHUDPos
		
		-- Update rocket ammo icon
		if not MovableMan:IsParticle(self.PayloadIcon) or self.PayloadIcon.PresetName ~= "Rocket Ammo" then
			self.PayloadIcon = CreateMOSRotating("Rocket Ammo", "Gunship.rte")
			self.PayloadIcon.Frame = math.ceil((self.PayloadIcon.FrameCount-1) * self.payload / self.maxPayload)
			MovableMan:AddParticle(self.PayloadIcon)
		end
		
		self.PayloadIcon.Vel = self.Vel
		self.PayloadIcon.AngularVel = 0
		self.PayloadIcon.RotAngle = 0
		self.PayloadIcon.Pos = self.AboveHUDPos + Vector(0, -3)
		
		-- Aim
		if not self.landingMode then
			if self.AnalogAim then
				self.aim = self.Ctrl.AnalogAim.AbsRadAngle
				if self.HFlipped then
					if self.aim > 1.57 + self.RotAngle then
						self.aim = math.max(self.aim, 2.89 + self.RotAngle)
					else
						self.aim = math.min(self.aim, -0.34 + self.RotAngle)
					end
				else
					if self.aim > 1.57 + self.RotAngle then
						self.aim = math.max(self.aim, 3.5 + self.RotAngle)
					else
						self.aim = math.min(self.aim, 0.25 + self.RotAngle)
					end
				end
				
				gunAim = self.aim
			else
				if self.Ctrl:IsState(Controller.BODY_JUMP) then
					if self.HFlipped then
						self.aim = self.aim - 0.04
					else
						self.aim = self.aim + 0.04
					end
				elseif self.Ctrl:IsState(Controller.BODY_CROUCH) then
					if self.HFlipped then
						self.aim = self.aim + 0.04
					else
						self.aim = self.aim - 0.04
					end
				elseif self.Ctrl.AnalogAim.Magnitude > 0 then
					self.AnalogAim = true
				end
				
				if self.aim > 6.2832 then
					self.aim = self.aim - 6.2832
				elseif self.aim < -1.5708 then
					self.aim = self.aim + 6.2832
				end
				
				if self.HFlipped then
					if self.aim > 1.57 then
						self.aim = math.max(self.aim, 2.89)
					else
						self.aim = math.min(self.aim, -0.34)
					end
				else
					if self.aim > 1.57 then
						self.aim = math.max(self.aim, 3.5)
					else
						self.aim = math.min(self.aim, 0.25)
					end
				end
				
				gunAim = self.RotAngle + self.aim
			end
			
			-- Update the aim
			for i = 1, 3 do
				if not MovableMan:IsParticle(self.AimDots[i]) or self.AimDots[i].PresetName ~= "Aim" then
					self.AimDots[i] = CreateMOSParticle("Aim", "Gunship.rte")
					MovableMan:AddParticle(self.AimDots[i])
				end
				
				self.AimDots[i].Age = 1
				self.AimDots[i].Vel = self.Vel
				self.AimDots[i].Pos = GSOffset(GunOffset, gunAim, 190 + i*10)
				
				if SceneMan.SceneWrapsX and self.AimDots[i].Pos.X > SceneMan.SceneWidth then
					self.AimDots[i].Pos.X = self.AimDots[i].Pos.X - SceneMan.SceneWidth
				end
			end
			
			if self.ammo > 0 and self.GunTimer:IsPastSimMS(80) and self.Ctrl:IsState(Controller.WEAPON_FIRE) then
				self.GunTimer:Reset()
				
				local bulletType = "MG Flash"
				if self.ammo % 4 == 0 then
					bulletType = "MG Flash Tracer"
				end
				
				local Emitter = CreateAEmitter(bulletType, "MyGunship.rte")
				Emitter.Vel = self.Vel
				Emitter.Pos = GunOffset + self.Barrel:RotateOffset(Vector(22, 1))
				Emitter.RotAngle = gunAim
				Emitter.Age = 1
				MovableMan:AddParticle(Emitter)
				
				local Casing = CreateMOSParticle("Gunship MG Casing", "Gunship.rte")
				Casing.Pos = GunOffset + self.Barrel:RotateOffset(Vector(4, 6))
				Casing.RotAngle = self.Barrel.RotAngle + RangeRand(-0.5,0.5)
				Casing.AngularVel = RangeRand(-2,7)
				
				if self.HFlipped then
					Casing.Vel = GSOffset(self.Vel * RangeRand(0.8,1.05), gunAim + RangeRand(1.47,1.67), 5)
				else
					Casing.Vel = GSOffset(self.Vel * RangeRand(0.8,1.05), gunAim - RangeRand(1.47,1.67), 5)
				end
				
				MovableMan:AddParticle(Casing)
				
				self.Barrel:SetNextFrame()
				
				-- Update ammo
				self.ammo = self.ammo - 1
				self.MGIcon.Frame = math.ceil((self.MGIcon.FrameCount-1) * self.ammo / self.maxAmmo)
			end
			
			self.ViewPoint = self.Pos + Vector(math.cos(gunAim) * self.SharpLength.X, -math.sin(gunAim) * self.SharpLength.Y)
			
			if self.payload > 0 and self.SecondaryTimer:IsPastSimMS(200) and ((self.Ctrl:IsMouseControlled() and SecondaryKey()) or
				(not self.Ctrl:IsMouseControlled() and self.Ctrl:IsState(Controller.AIM_SHARP)))
			then
				self.SecondaryTimer:Reset()
				
				local Rocket = CreateAEmitter("Cannon Flash HE", "Gunship.rte")
				Rocket.Pos = self.Pos + self:RotateOffset(Vector(math.abs(Rocket.SpriteOffset.X) + 27, -19))
				
				if self.HFlipped then
					Rocket.RotAngle = self.RotAngle + 3.141592
				else
					Rocket.RotAngle = self.RotAngle
				end
				
				Rocket.Vel = self.Vel
				MovableMan:AddParticle(Rocket)
				
				-- Update ammo
				self.payload = self.payload - 1
				self.PayloadIcon.Frame = math.ceil((self.PayloadIcon.FrameCount-1) * self.payload / self.maxPayload)
			end
		end
	elseif self.player then
		self.player = false	-- only execute this code once after the player has switched actor
		
		for i = 1, 3 do
			if MovableMan:IsParticle(self.AimDots[i]) then
				self.AimDots[i].ToDelete = true
			end
		end
		
		if MovableMan:IsParticle(self.PayloadIcon) then
			self.PayloadIcon.ToDelete = true
		end
		
		if MovableMan:IsParticle(self.MGIcon) then
			self.MGIcon.ToDelete = true
		end
	else	-- AI hover mode
		self.RotAngle = self.RotAngle * 0.993
		self.Vel.X = self.Vel.X * 0.97
		if math.abs(self.Vel.Y) > 4 then
			self.Vel.Y = self.Vel.Y * 0.99
		end
		
		if self.landingMode then
			self.Ctrl:SetState(Controller.MOVE_UP, false)
		end
	end
		
	
	local Acc = Vector(0, 0)
	local power
	if self.landingMode then
		power = {4000, 2000, 4000, 15000, 800, 8000}
	else
		power = {12000, 1000, 5000, 18000, 500, 11000}
	end
	
	-- Rotate
	if self.Ctrl:IsState(Controller.MOVE_LEFT) and self.AngularVel < 2 then
		if self.HFlipped then
			Acc:SetMagnitude(power[1]) -- Facing left; accelerate
		else
			if self.RotAngle < 0 then
				Acc:SetMagnitude(power[2])	-- Facing right; do not break hard until level
			else
				Acc:SetMagnitude(power[3])	-- Facing right; break
			end
		end
		
		Acc:RadRotate(self.RotAngle/2 + 3.141592)
		self.AngularVel = self.AngularVel + 0.124
	elseif self.Ctrl:IsState(Controller.MOVE_RIGHT) and self.AngularVel > -2 then
		if self.HFlipped then
			if self.RotAngle > 0 then
				Acc:SetMagnitude(power[2])	-- Facing left; do not break hard until level
			else
				Acc:SetMagnitude(power[3])	-- Facing left; break
			end
		else
			Acc:SetMagnitude(power[1]) -- Facing right; accelerate
		end
		
		self.AngularVel = self.AngularVel - 0.124
		Acc:RadRotate(self.RotAngle/2)
	else
		self.AngularVel = self.AngularVel * 0.96
	end
	
	-- Lift
	local Lft = Vector(0, 0)
	if self.Ctrl:IsState(Controller.MOVE_UP) then
		Lft:SetMagnitude(power[4])
	elseif self.Ctrl:IsState(Controller.MOVE_DOWN) then
		Lft:SetMagnitude(power[5])
	else
		Lft:SetMagnitude(power[6])
		
		-- Stabilize
		if self.RotAngle > 0 then
			self.AngularVel = self.AngularVel - 0.01
		elseif self.RotAngle < -0 then
			self.AngularVel = self.AngularVel + 0.01
		end
	end
	
	Lft:RadRotate(self.RotAngle)
	self:AddAbsForce(Lft.Perpendicular + Acc + Vector(0, -1500), self.Pos)
	
	if self.landingMode or not self.player then
		if self.HFlipped then	-- Move aim towards zero
			if self.aim > 3.16 or self.aim < 0 then
				self.aim = self.aim - 0.03
			elseif self.aim < 3.12 then
				self.aim = self.aim + 0.03
			end
		else
			if self.aim < -0.02 or self.aim > 3.14 then
				self.aim = self.aim + 0.03
			elseif self.aim > 0.02 then
				self.aim = self.aim - 0.03
			end
		end
		
		if self.aim > 6.2832 then
			self.aim = self.aim - 6.2832
		elseif self.aim < -1.5708 then
			self.aim = self.aim + 6.2832
		end
		
		gunAim = self.RotAngle + self.aim
		
		-- Remove the aim dots
		if self.AimDots[1] then
			for i = 1, 3 do
				if MovableMan:IsParticle(self.AimDots[i]) then
					self.AimDots[i].ToDelete = true
				end
			end
		end
	end
	
	if self.landingMode then
		-- Animate gears
		if self.Frame > 0 and self.GearTimer:IsPastSimMS(90) then
			self.GearTimer:Reset()
			self.Frame = self.Frame - 1
		end
			
		if (self.Health < 100 or self.ammo < self.maxAmmo or self.payload < self.maxPayload) and self.Vel.Magnitude < 0.5 then
			local repair
			for i, Act in pairs(self.LandingPads) do
				if MovableMan:ValidMO(Act) and Act.ClassName ~= "Entity" then 
					if SceneMan:ShortestDistance(self.Pos, Act.Pos, true).Magnitude < 100 then
						Act.Sharpness = 2
						repair = true
						break
					end
				else
					table.remove(self.LandingPads, i)
					break
				end
			end
			
			if repair then
				if self.SecondaryTimer:IsPastSimMS(50) then
					self.SecondaryTimer:Reset()
					
					self.Health = math.min(self.Health + 1, 100)
					self.ammo = math.min(self.ammo + self.maxAmmo * 0.02, self.maxAmmo)
					self.payload = math.min(self.payload + self.maxPayload * 0.02, self.maxPayload)
					self.MGIcon.Frame = math.ceil((self.MGIcon.FrameCount-1) * self.ammo / self.maxAmmo)
					self.PayloadIcon.Frame = math.ceil((self.PayloadIcon.FrameCount-1) * self.payload / self.maxPayload)
					self.Vel = self.Vel * 0.98
				end
				
				if not MovableMan:IsParticle(self.RepairCross) or self.RepairCross.PresetName ~= "Repair" then
					self.RepairCross = CreateMOSParticle("Repair", "Gunship.rte")
					MovableMan:AddParticle(self.RepairCross)
				end
				
				self.RepairCross.Age = 1
				self.RepairCross.Vel = self.Vel
				self.RepairCross.Pos = self.AboveHUDPos + Vector(0, -12)
			end
		end
	elseif self.Frame < self.FrameCount - 1 and self.GearTimer:IsPastSimMS(90) then	-- Animate landing gears
		self.GearTimer:Reset()
		self.Frame = self.Frame + 1
	end
	
	-- Update barrel
	self.Barrel.Pos = GunOffset
	self.Barrel.RotAngle = gunAim
	self.Barrel.HFlipped = self.HFlipped
	
	if self.HFlipped then
		self.Barrel.RotAngle = self.Barrel.RotAngle + 3.141592
	end
end

function GSOffset(Origin, ang, dist)
	if Origin then
		return Vector(Origin.X, Origin.Y) + Vector(dist,0):RadRotate(ang)	-- this way it does not matter if Origin is a const vector
	end
	return Vector(dist,0):RadRotate(ang)
end